#ifndef SM21

uint reverse(uint value)
{
uint tmp1,tmp2,tmp3,tmp4,tmp;
tmp1=value&255;
tmp2=(value>>8)&255;
tmp3=(value>>16)&255;
tmp4=(value>>24)&255;
tmp=(tmp3<<8)|(tmp2<<16)|(tmp1<<24);
tmp+=tmp4;
return tmp;
}

__kernel void mysql_old( __global uint *dst, uint4 input, uint size,  uint8 chbase,  __global uint *found_ind, __global uint *bitmaps, __global uint *found, __global  uint *table,  uint4 singlehash, uint8 precalc) 
{  
uint i,ib,ic,id,b1,b2,b3;  
uint a,b,c,d,tmp,tmp1,tmp2,A,B; 
uint l; 
uint a1,a2,a3,a4,chbase1; 

#define Endian_Reverse32(a) { (a)=reverse((a)); }

i = table[get_global_id(0)];
ib = (uint)i&255;  
ic = (uint)((i>>8)&255);
id = (uint)((i>>16)&255);  

chbase1=chbase.s0;
a = input.x;
b = input.y;
c = input.z;


//a1 = a ^ (mad24(((a & 63) + c), chbase1,  (a << 8)));
a1=precalc.s0;
c += chbase1;
a2 = a1 ^ (mad24(((a1 & 63) + c), ib,  (a1 << 8)));
c += ib;
a3 = a2 ^ (mad24(((a2 & 63) + c), ic,  (a2 << 8)));
c += ic;
a4 = a3 ^ (mad24(((a3 & 63) + c), id,  (a3 << 8)));


A=a4&0x7FFFFFFF;
Endian_Reverse32(A);

#ifdef SINGLE_MODE
id = 0;
if (singlehash.x!=A) return;
#endif

b += (b << 8) ^ a1;
b += (b << 8) ^ a2;
b += (b << 8) ^ a3;
b += (b << 8) ^ a4;

B=b&0x7FFFFFFF;
Endian_Reverse32(B);

#ifdef SINGLE_MODE

if (singlehash.y==B) id=1;
if (id==0) return;
id=1;

#endif

#ifndef SINGLE_MODE

id = 0;
b1=A;b2=B;
b3=(singlehash.x >> (B&31))&1;
if (b3) if ( ((bitmaps[b1>>13]>>(b1&31))&1) && ((bitmaps[65535*8+(b2>>13)]>>(b2&31))&1) ) id=1;
#endif

if (id==1) 
{
found[0] = 1;
found_ind[get_global_id(0)] = 1;
}


dst[(get_global_id(0)<<1)] = A;
dst[(get_global_id(0)<<1)+1] = B;


}



#else


uint4 reverse(uint4 value)
{
uint4 tmp1,tmp2,tmp3,tmp4,tmp;
tmp1=value&255;
tmp2=(value>>8)&255;
tmp3=(value>>16)&255;
tmp4=(value>>24)&255;
tmp=(tmp3<<8)|(tmp2<<16)|(tmp1<<24);
tmp+=tmp4;
return tmp;
}

__kernel void mysql_old( __global uint4 *dst, uint4 input, uint size,  uint8 chbase,  __global uint *found_ind, __global uint *bitmaps, __global uint *found, __global  uint *table,  uint4 singlehash, uint8 precalc) 
{  
uint i,ib,ic,id,b1,b2,b3;  
uint4 a,b,c,d,tmp,tmp1,tmp2,A,B; 
uint4 l; 
uint4 a1,a2,a3,a4,chbase1,precalc1; 

#define Endian_Reverse32(a) { (a)=reverse((a)); }

i = table[get_global_id(0)];
ib = (uint)i&255;  
ic = (uint)((i>>8)&255);
id = (uint)((i>>16)&255);  

chbase1=(uint4)(chbase.s0,chbase.s1,chbase.s2,chbase.s3);
precalc1=(uint4)(precalc.s0,precalc.s1,precalc.s2,precalc.s3);
a = (uint4)input.x;
b = (uint4)input.y;
c = (uint4)input.z;


//a1 = a ^ (mad24(((a & 63) + c), chbase1,  (a << 8)));
a1=precalc1;
c += chbase1;
a2 = a1 ^ (mad24(((a1 & 63) + c), ib,  (a1 << 8)));
c += ib;
a3 = a2 ^ (mad24(((a2 & 63) + c), ic,  (a2 << 8)));
c += ic;
a4 = a3 ^ (mad24(((a3 & 63) + c), id,  (a3 << 8)));


A=a4&0x7FFFFFFF;
Endian_Reverse32(A);

#ifdef SINGLE_MODE
id = 0;
if (all((uint4)singlehash.x!=A)) return;
#endif

b += (b << 8) ^ a1;
b += (b << 8) ^ a2;
b += (b << 8) ^ a3;
b += (b << 8) ^ a4;

B=b&0x7FFFFFFF;
Endian_Reverse32(B);

#ifdef SINGLE_MODE

if (all((uint4)singlehash.y==B)) return;
id=1;

#endif

#ifndef SINGLE_MODE
id = 0;
b1=A.s0;b2=B.s0;
b3=(singlehash.x >> (B.s0&31))&1;
if (b3) if ( ((bitmaps[b1>>13]>>(b1&31))&1) && ((bitmaps[65535*8+(b2>>13)]>>(b2&31))&1) ) id=1;
b1=A.s1;b2=B.s1;
b3=(singlehash.x >> (B.s1&31))&1;
if (b3) if ( ((bitmaps[b1>>13]>>(b1&31))&1) && ((bitmaps[65535*8+(b2>>13)]>>(b2&31))&1) ) id=1;
b1=A.s2;b2=B.s2;
b3=(singlehash.x >> (B.s2&31))&1;
if (b3) if ( ((bitmaps[b1>>13]>>(b1&31))&1) && ((bitmaps[65535*8+(b2>>13)]>>(b2&31))&1) ) id=1;
b1=A.s3;b2=B.s3;
b3=(singlehash.x >> (B.s3&31))&1;
if (b3) if ( ((bitmaps[b1>>13]>>(b1&31))&1) && ((bitmaps[65535*8+(b2>>13)]>>(b2&31))&1) ) id=1;

if (id==0) return;
#endif

if (id==1) 
{
found[0] = 1;
found_ind[get_global_id(0)] = 1;
}

dst[(get_global_id(0)<<1)] = (uint4)(A.s0,B.s0,A.s1,B.s1);
dst[(get_global_id(0)<<1)+1] = (uint4)(A.s2,B.s2,A.s3,B.s3);

}



#endif