/* threads.h
 *
 * hashkill - a hash cracking tool
 * Copyright (C) 2010 Milen Rangelov <gat3way@gat3way.eu>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#ifndef OCLHASHTHREADS_H
#define OCLHASHTHREADS_H

#include <stdint.h>
#include "err.h"
#include "hashinterface.h"

/* function prototypes */
hash_stat ocl_get_device();
hash_stat ocl_bruteforce();
hash_stat ocl_markov();
hash_stat ocl_spawn_threads(unsigned int num, unsigned int queue_size);
hash_stat ocl_restore_counts(uint64_t current, uint64_t overall);

/* globals */
int invocations;
pthread_mutex_t listmutex;
pthread_mutex_t crackedmutex;
uint64_t attack_overall_count;
uint64_t attack_current_count;
int hash_len;
int ocl_dev_nvidia;
int ocl_dev_amd;
int ocl_vector;
int ocl_threads;
int ocl_user_threads;	// provided by --gpu-threads
int ocl_have_old_ati;
int ocl_have_sm21;


struct thread_restore_t
{
    int cpos[16];
    char cstr[16];
    int cstart;
} thread_restore[64], thread_save[64];



#endif
