/* ocl_support.h
 *
 * hashkill - a hash cracking tool
 * Copyright (C) 2010 Milen Rangelov <gat3way@gat3way.eu>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#ifndef OCL_SUPPORT_H
#define OCL_SUPPORT_H

#include <stdint.h>
#include "err.h"
//#include "hashinterface.h"

/* md5 plugin support */
hash_stat ocl_bruteforce_md5(void);
hash_stat ocl_markov_md5(void);
hash_stat ocl_hybrid_md5(void);

/* sha1 plugin support */
hash_stat ocl_bruteforce_sha1(void);
hash_stat ocl_markov_sha1(void);
hash_stat ocl_hybrid_sha1(void);

/* md4 plugin support */
hash_stat ocl_bruteforce_md4(void);
hash_stat ocl_markov_md4(void);
hash_stat ocl_hybrid_md4(void);

/* ntlm plugin support */
hash_stat ocl_bruteforce_ntlm(void);
hash_stat ocl_markov_ntlm(void);
hash_stat ocl_hybrid_ntlm(void);

/* md5md5 plugin support */
hash_stat ocl_bruteforce_md5md5(void);
hash_stat ocl_markov_md5md5(void);
hash_stat ocl_hybrid_md5md5(void);

/* sl3 plugin support */
hash_stat ocl_bruteforce_sl3(void);

/* mysql5 plugin support */
hash_stat ocl_bruteforce_mysql5(void);
hash_stat ocl_markov_mysql5(void);
hash_stat ocl_hybrid_mysql5(void);

/* mysql-old plugin support */
hash_stat ocl_bruteforce_mysql_old(void);
hash_stat ocl_markov_mysql_old(void);
hash_stat ocl_hybrid_mysql_old(void);

/* ldap-sha plugin support */
hash_stat ocl_bruteforce_ldap_sha(void);
hash_stat ocl_markov_ldap_sha(void);
hash_stat ocl_hybrid_ldap_sha(void);

/* sha256 plugin support */
hash_stat ocl_bruteforce_sha256(void);
hash_stat ocl_markov_sha256(void);
hash_stat ocl_hybrid_sha256(void);

/* sha512 plugin support */
/*
hash_stat ocl_bruteforce_sha512(void);
hash_stat ocl_markov_sha512(void);
hash_stat ocl_hybrid_sha512(void);
*/

/* md5-passsalt plugin support */
//hash_stat ocl_bruteforce_md5_passsalt(void);
//hash_stat ocl_markov_md5_passsalt(void);
//hash_stat ocl_hybrid_md5_passsalt(void);



/* supported plugins struct array*/
struct ocl_supported_plugins_s
{
    int is_linear;
    char plugin_name[32];
    hash_stat (*bruteforce_routine)(void);
    hash_stat (*markov_routine)(void);
    hash_stat (*hybrid_routine)(void);
};

#endif
